Index: codes/icosagcm/trunk/src/check_conserve.f90
===================================================================
--- codes/icosagcm/trunk/src/check_conserve.f90	(revision 185)
+++ codes/icosagcm/trunk/src/check_conserve.f90	(revision 186)
@@ -10,7 +10,9 @@
   PUBLIC init_check_conserve, check_conserve 
     REAL(rstd),SAVE:: mtot0,ztot0,etot0,ang0,stot0,rmsv0
+!$OMP THREADPRIVATE(mtot0,ztot0,etot0,ang0,stot0,rmsv0)
     REAL(rstd),SAVE:: etot,ang,stot,rmsv
+!$OMP THREADPRIVATE(etot,ang,stot,rmsv)
     REAL(rstd),SAVE:: ztot
-	
+!$OMP THREADPRIVATE(ztot)	
      
 CONTAINS 
@@ -53,4 +55,5 @@
 
     DO ind=1,ndomain 
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -67,5 +70,5 @@
 
     IF (is_mpi_root) THEN 
-       
+!$OMP MASTER       
        IF ( it == 0  ) Then 
           ztot0 = ztot
@@ -87,8 +90,9 @@
        WRITE(*,4000)mtot,rmsdpdt,etot,ztot,stot,rmsv,ang
        
-4000   FORMAT(10x,'masse',4x,'rmsdpdt',7x,'energie',2x,'enstrophie'  &
-            ,2x,'entropie',3x,'rmsv',4x,'mt.ang',/,'GLOB  '                &
+4000   FORMAT(10x,'masse',5x,'rmsdpdt',5x,'energie',5x,'enstrophie'  &
+            ,5x,'entropie',5x,'rmsv',5x,'mt.ang',/,'GLOB  '                &
             ,e10.3,e13.6,5e10.3/)     
-       close(134) 
+       close(134)
+!$OMP END MASTER 
     END IF
   END SUBROUTINE check_conserve
@@ -99,4 +103,5 @@
   USE mpi_mod
   USE mpipara
+  USE transfert_omp_mod
   USE icosa
   IMPLICIT NONE
@@ -108,7 +113,9 @@
     INTEGER :: ind,i,j,ij  
     REAL :: mloc, rmsloc
+    REAL :: mloc_mpi, rmsloc_mpi
 
     mloc=0.0; rmsloc=0.0
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -127,6 +134,12 @@
 
     IF (using_mpi) THEN
-      CALL MPI_REDUCE(mloc, mtot, 1, MPI_REAL8, MPI_SUM, 0, comm_icosa, ierr)
-      CALL MPI_REDUCE(rmsloc, rmsdpdt, 1, MPI_REAL8, MPI_SUM, 0, comm_icosa, ierr)
+        CALL reduce_sum_omp(mloc, mloc_mpi)
+        CALL reduce_sum_omp(rmsloc, rmsloc_mpi)
+!$OMP MASTER    
+      CALL MPI_REDUCE(mloc_mpi, mtot, 1, MPI_REAL8, MPI_SUM, 0, comm_icosa, ierr)
+      CALL MPI_REDUCE(rmsloc_mpi, rmsdpdt, 1, MPI_REAL8, MPI_SUM, 0, comm_icosa, ierr)
+!$OMP END MASTER
+    ELSE
+      
     ENDIF
     
@@ -153,4 +166,5 @@
 
     DO ind=1,ndomain 
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -260,4 +274,5 @@
 
      DO ind=1,ndomain 
+       IF (.NOT. assigned_domain(ind)) CYCLE
        CALL swap_dimensions(ind)
        CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/dcmip_initial_conditions_test_1_2_3_v5.f90
===================================================================
--- codes/icosagcm/trunk/src/dcmip_initial_conditions_test_1_2_3_v5.f90	(revision 185)
+++ codes/icosagcm/trunk/src/dcmip_initial_conditions_test_1_2_3_v5.f90	(revision 186)
@@ -260,6 +260,6 @@
 	r  = ACOS (sin_tmp + cos_tmp*cos(lon-lambda0)) 
 	r2  = ACOS (sin_tmp2 + cos_tmp2*cos(lon-lambda1)) 
-	d1 = min( 1.d0, (r/RR)**2 + ((height-z0)/ZZ)**2 )
-	d2 = min( 1.d0, (r2/RR)**2 + ((height-z0)/ZZ)**2 )
+	d1 = min( 1., (r/RR)**2 + ((height-z0)/ZZ)**2 )
+	d2 = min( 1., (r2/RR)**2 + ((height-z0)/ZZ)**2 )
 	
 	q1 = 0.5d0 * (1.d0 + cos(pi*d1)) + 0.5d0 * (1.d0 + cos(pi*d2))
Index: codes/icosagcm/trunk/src/dimensions.f90
===================================================================
--- codes/icosagcm/trunk/src/dimensions.f90	(revision 185)
+++ codes/icosagcm/trunk/src/dimensions.f90	(revision 186)
@@ -1,41 +1,74 @@
 MODULE dimensions
 
-    INTEGER :: iim
-    INTEGER :: jjm
-    INTEGER :: ii_begin
-    INTEGER :: jj_begin
-    INTEGER :: ii_end
-    INTEGER :: jj_end
-    INTEGER :: ii_nb
-    INTEGER :: jj_nb
-    INTEGER :: ij_begin
-    INTEGER :: ij_end
-    INTEGER :: ij_begin_ext
-    INTEGER :: ij_end_ext
+    INTEGER,SAVE :: iim
+!$OMP THREADPRIVATE(iim)
+    INTEGER,SAVE :: jjm
+!$OMP THREADPRIVATE(jjm)
+    INTEGER,SAVE :: ii_begin
+!$OMP THREADPRIVATE(ii_begin)
+    INTEGER,SAVE :: jj_begin
+!$OMP THREADPRIVATE(jj_begin)
+    INTEGER,SAVE :: ii_end
+!$OMP THREADPRIVATE(ii_end)
+    INTEGER,SAVE :: jj_end
+!$OMP THREADPRIVATE(jj_end)
+    INTEGER,SAVE :: ii_nb
+!$OMP THREADPRIVATE(ii_nb)
+    INTEGER,SAVE :: jj_nb
+!$OMP THREADPRIVATE(jj_nb)
+    INTEGER,SAVE :: ij_begin
+!$OMP THREADPRIVATE(ij_begin)
+    INTEGER,SAVE :: ij_end
+!$OMP THREADPRIVATE(ij_end)
+    INTEGER,SAVE :: ij_begin_ext
+!$OMP THREADPRIVATE(ij_begin_ext)
+    INTEGER,SAVE :: ij_end_ext
+!$OMP THREADPRIVATE(ij_end_ext)
         
-    INTEGER :: t_right
-    INTEGER :: t_rup
-    INTEGER :: t_lup
-    INTEGER :: t_left
-    INTEGER :: t_ldown
-    INTEGER :: t_rdown
+    INTEGER,SAVE :: t_right
+!$OMP THREADPRIVATE(t_right)
+    INTEGER,SAVE :: t_rup
+!$OMP THREADPRIVATE(t_rup)
+    INTEGER,SAVE :: t_lup
+!$OMP THREADPRIVATE(t_lup)
+    INTEGER,SAVE :: t_left
+!$OMP THREADPRIVATE(t_left)
+    INTEGER,SAVE :: t_ldown
+!$OMP THREADPRIVATE(t_ldown)
+    INTEGER,SAVE :: t_rdown
+!$OMP THREADPRIVATE(t_rdown)
 
-    INTEGER :: u_right
-    INTEGER :: u_rup
-    INTEGER :: u_lup
-    INTEGER :: u_left
-    INTEGER :: u_ldown
-    INTEGER :: u_rdown
+    INTEGER,SAVE :: u_right
+!$OMP THREADPRIVATE(u_right)
+    INTEGER,SAVE :: u_rup
+!$OMP THREADPRIVATE(u_rup)
+    INTEGER,SAVE :: u_lup
+!$OMP THREADPRIVATE(u_lup)
+    INTEGER,SAVE :: u_left
+!$OMP THREADPRIVATE(u_left)
+    INTEGER,SAVE :: u_ldown
+!$OMP THREADPRIVATE(u_ldown)
+    INTEGER,SAVE :: u_rdown
+!$OMP THREADPRIVATE(u_rdown)
 
-    INTEGER :: z_rup
-    INTEGER :: z_up
-    INTEGER :: z_lup
-    INTEGER :: z_ldown
-    INTEGER :: z_down
-    INTEGER :: z_rdown
+    INTEGER,SAVE :: z_rup
+!$OMP THREADPRIVATE(z_rup)
+    INTEGER,SAVE :: z_up
+!$OMP THREADPRIVATE(z_up)
+    INTEGER,SAVE :: z_lup
+!$OMP THREADPRIVATE(z_lup)
+    INTEGER,SAVE :: z_ldown
+!$OMP THREADPRIVATE(z_ldown)
+    INTEGER,SAVE :: z_down
+!$OMP THREADPRIVATE(z_down)
+    INTEGER,SAVE :: z_rdown
+!$OMP THREADPRIVATE(z_rdown)
 
-    INTEGER :: t_pos(6)
-    INTEGER :: u_pos(6)
-    INTEGER :: z_pos(6)
+    INTEGER,SAVE :: t_pos(6)
+!$OMP THREADPRIVATE(t_pos)
+    INTEGER,SAVE :: u_pos(6)
+!$OMP THREADPRIVATE(u_pos)
+    INTEGER,SAVE :: z_pos(6)
+!$OMP THREADPRIVATE(z_pos)
         
 CONTAINS
@@ -48,6 +81,4 @@
     TYPE(t_domain),POINTER :: d
     
-    
-!$OMP MASTER
     d=>domain(ind)
      
@@ -91,6 +122,4 @@
      z_pos(:)=d%z_pos(:)
 
-!$OMP END MASTER     
-!$OMP BARRIER
    END SUBROUTINE swap_dimensions
    
Index: codes/icosagcm/trunk/src/dissip_gcm.f90
===================================================================
--- codes/icosagcm/trunk/src/dissip_gcm.f90	(revision 185)
+++ codes/icosagcm/trunk/src/dissip_gcm.f90	(revision 186)
@@ -10,22 +10,34 @@
   TYPE(t_field),POINTER,SAVE :: f_dtheta_diss(:)
   TYPE(t_field),POINTER,SAVE :: f_dtheta_rhodz_diss(:)
-  TYPE(t_message) :: req_due, req_dtheta 
+  TYPE(t_message),SAVE :: req_due, req_dtheta 
  
   INTEGER,SAVE :: nitergdiv=1
+!$OMP THREADPRIVATE(nitergdiv)
   INTEGER,SAVE :: nitergrot=1
+!$OMP THREADPRIVATE(nitergrot)
   INTEGER,SAVE :: niterdivgrad=1
+!$OMP THREADPRIVATE(niterdivgrad)
 
   REAL,ALLOCATABLE,SAVE :: tau_graddiv(:)
+!$OMP THREADPRIVATE(tau_graddiv)
   REAL,ALLOCATABLE,SAVE :: tau_gradrot(:)
+!$OMP THREADPRIVATE(tau_gradrot)
   REAL,ALLOCATABLE,SAVE :: tau_divgrad(:)
+!$OMP THREADPRIVATE(tau_divgrad)
   
   REAL,SAVE :: cgraddiv
+!$OMP THREADPRIVATE(cgraddiv)
   REAL,SAVE :: cgradrot
+!$OMP THREADPRIVATE(cgradrot)
   REAL,SAVE :: cdivgrad
+!$OMP THREADPRIVATE(cdivgrad)
 
   INTEGER, SAVE :: rayleigh_friction_type, rayleigh_shear
-  REAL, save    :: rayleigh_tau
+!$OMP THREADPRIVATE(rayleigh_friction_type)
+  REAL, SAVE    :: rayleigh_tau
+!$OMP THREADPRIVATE(rayleigh_shear)
   
   REAL,SAVE    :: dtdissip
+!$OMP THREADPRIVATE(dtdissip)
  
   PUBLIC init_dissip, dissip
@@ -58,13 +70,13 @@
   USE transfert_mod
   USE time_mod
-  
+  USE transfert_omp_mod
   IMPLICIT NONE
   
-  TYPE(t_field),POINTER :: f_u(:)
-  TYPE(t_field),POINTER :: f_du(:)
-  REAL(rstd),POINTER    :: u(:)
-  REAL(rstd),POINTER    :: du(:)
-  TYPE(t_field),POINTER :: f_theta(:)
-  TYPE(t_field),POINTER :: f_dtheta(:)
+  TYPE(t_field),POINTER,SAVE  :: f_u(:)
+  TYPE(t_field),POINTER,SAVE  :: f_du(:)
+  REAL(rstd),POINTER     :: u(:)
+  REAL(rstd),POINTER     :: du(:)
+  TYPE(t_field),POINTER,SAVE  :: f_theta(:)
+  TYPE(t_field),POINTER ,SAVE :: f_dtheta(:)
   REAL(rstd),POINTER    :: theta(:)
   REAL(rstd),POINTER    :: dtheta(:)
@@ -128,5 +140,5 @@
     
     tau_gradrot(:)=5000
-    CALL getin("tau_gradrot",tau_gradrot)
+    CALL getin("tau_gradrot",tau)
     tau_gradrot(:)=tau/scale_factor
 
@@ -146,4 +158,5 @@
     
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -171,4 +184,5 @@
         CALL transfert_request(f_u,req_e1_vect)
         DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
@@ -183,4 +197,5 @@
       
       DO ind=1,ndomain
+        IF (.NOT. assigned_domain(ind)) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -199,9 +214,16 @@
 
       IF (using_mpi) THEN 
-        CALL MPI_ALLREDUCE(dumax,dumax1,1,MPI_REAL8,MPI_MAX,comm_icosa,ierr)
+        CALL reduce_sum_omp(dumax,dumax1)
+!$OMP MASTER        
+        CALL MPI_ALLREDUCE(dumax1,dumax,1,MPI_REAL8,MPI_MAX,comm_icosa,ierr)
+!$OMP END MASTER     
+        CALL bcast_omp(dumax)  
+      ELSE
+        CALL allreduce_sum_omp(dumax,dumax1)
         dumax=dumax1
-      ENDIF
+      ENDIF  
 			
       DO ind=1,ndomain
+        IF (.NOT. assigned_domain(ind)) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -223,4 +245,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -247,4 +270,5 @@
         CALL transfert_request(f_u,req_e1_vect)
         DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
@@ -259,4 +283,5 @@
       
       DO ind=1,ndomain
+        IF (.NOT. assigned_domain(ind)) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -274,10 +299,18 @@
       ENDDO
 
-      IF (using_mpi) THEN
-        CALL MPI_ALLREDUCE(dumax,dumax1,1,MPI_REAL8,MPI_MAX,comm_icosa,ierr)
+      IF (using_mpi) THEN 
+        CALL reduce_sum_omp(dumax,dumax1)
+!$OMP MASTER        
+        CALL MPI_ALLREDUCE(dumax1,dumax,1,MPI_REAL8,MPI_MAX,comm_icosa,ierr)
+!$OMP END MASTER     
+        CALL bcast_omp(dumax)  
+      ELSE
+        CALL allreduce_sum_omp(dumax,dumax1)
         dumax=dumax1
-      ENDIF
+      ENDIF  
+
       
       DO ind=1,ndomain
+        IF (.NOT. assigned_domain(ind)) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -298,4 +331,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -317,4 +351,5 @@
         CALL transfert_request(f_theta,req_i1)
         DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
@@ -329,4 +364,5 @@
       
       DO ind=1,ndomain
+        IF (.NOT. assigned_domain(ind)) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -341,13 +377,20 @@
         ENDDO
       ENDDO
-      
-      IF (using_mpi) THEN
-        CALL MPI_ALLREDUCE(dthetamax,dthetamax1,1,MPI_REAL8,MPI_MAX,comm_icosa,ierr)
-	dthetamax=dthetamax1
-      ENDIF
+
+      IF (using_mpi) THEN 
+        CALL reduce_sum_omp(dthetamax ,dthetamax1)
+!$OMP MASTER        
+        CALL MPI_ALLREDUCE(dthetamax1,dthetamax,1,MPI_REAL8,MPI_MAX,comm_icosa,ierr)
+!$OMP END MASTER     
+        CALL bcast_omp(dthetamax)  
+      ELSE
+        CALL allreduce_sum_omp(dthetamax,dthetamax1)
+        dumax=dumax1
+      ENDIF  
       
       IF (is_mpi_root) PRINT *,"divgrad : it :",it ,": dthetamax",dthetamax
 
       DO ind=1,ndomain
+        IF (.NOT. assigned_domain(ind)) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -434,4 +477,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -524,4 +568,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -544,4 +589,5 @@
         
       DO ind=1,ndomain
+        IF (.NOT. assigned_domain(ind)) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -571,4 +617,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -591,4 +638,5 @@
         
       DO ind=1,ndomain
+        IF (.NOT. assigned_domain(ind)) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -618,4 +666,5 @@
        
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -630,4 +679,5 @@
         
       DO ind=1,ndomain
+        IF (.NOT. assigned_domain(ind)) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -661,4 +711,5 @@
        
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -679,4 +730,5 @@
       CALL wait_message(req_dtheta)
       DO ind=1,ndomain
+        IF (.NOT. assigned_domain(ind)) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -688,4 +740,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/disvert.f90
===================================================================
--- codes/icosagcm/trunk/src/disvert.f90	(revision 185)
+++ codes/icosagcm/trunk/src/disvert.f90	(revision 186)
@@ -2,13 +2,20 @@
   USE icosa
   REAL(rstd), SAVE, POINTER :: ap(:)
+!$OMP THREADPRIVATE(ap) 
   REAL(rstd), SAVE, POINTER :: bp(:)
+!$OMP THREADPRIVATE(bp) 
   REAL(rstd), SAVE, POINTER :: presnivs(:)
+!$OMP THREADPRIVATE(presnivs) 
   REAL(rstd), SAVE, POINTER :: mass_al(:), mass_bl(:), mass_ak(:), mass_bk(:), mass_dak(:), mass_dbk(:)
+!$OMP THREADPRIVATE(mass_al, mass_bl, mass_ak, mass_bk, mass_dak, mass_dbk) 
 
   REAL(rstd) :: ptop ! pressure at top of atmosphere l=llm+1
+!$OMP THREADPRIVATE(ptop) 
   ! vertical coordinate : Lagrangian or mass-based
   INTEGER, SAVE :: caldyn_eta
+!$OMP THREADPRIVATE(caldyn_eta) 
   INTEGER, PARAMETER :: eta_mass=1, eta_lag=2
   LOGICAL,SAVE :: ap_bp_present
+!$OMP THREADPRIVATE(ap_bp_present) 
 
 CONTAINS
@@ -42,4 +49,5 @@
     ap_bp_present=.TRUE.
     CALL getin("disvert",def)
+    PRINT*,"def --> ",def
     SELECT CASE (TRIM(def))
       CASE('none')
@@ -83,5 +91,6 @@
         bp=>bp_ncarl30
         presnivs=>presnivs_ncarl30
-        
+        PRINT*,"ap --> ",ap
+        PRINT*,"ap_ncarl30 --> ",ap_ncarl30
       CASE default
         IF (is_mpi_root) PRINT*,'Bad selector for variable disvert : <', TRIM(def),"> options are <std>, <ncar>, <ncarl30>" 
@@ -169,6 +178,8 @@
     INTEGER :: ncid,levid,ilevid,hyaiid,hybiid,hyamid,hybmid,P0id
     INTEGER :: l
-    
-   
+
+!$OMP BARRIER
+!$OMP MASTER    
+  IF(ap_bp_present) THEN
     status = NF90_CREATE('apbp.nc', NF90_CLOBBER, ncid)
     status = NF90_DEF_DIM(ncid,'lev',llm,lev)
@@ -204,6 +215,5 @@
 
     status = NF90_ENDDEF(ncid)   
-
-  IF(ap_bp_present) THEN
+    
     status=NF90_PUT_VAR(ncid,ilevid, ap(:)+bp(:)*Preff)
     
@@ -228,9 +238,9 @@
  
     status=NF90_PUT_VAR(ncid,P0id, Preff)
-
-  END IF
    
     status=NF90_CLOSE(ncid)
-
+  END IF
+!$OMP END MASTER
+!$OMP BARRIER
   END SUBROUTINE write_apbp
 
Index: codes/icosagcm/trunk/src/disvert_dcmip200.f90
===================================================================
--- codes/icosagcm/trunk/src/disvert_dcmip200.f90	(revision 185)
+++ codes/icosagcm/trunk/src/disvert_dcmip200.f90	(revision 186)
@@ -3,6 +3,9 @@
  
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: ap(:)
+!$OMP THREADPRIVATE(ap)
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: bp(:)
+!$OMP THREADPRIVATE(bp)
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: presnivs(:)
+!$OMP THREADPRIVATE(presnivs)
 
 CONTAINS
Index: codes/icosagcm/trunk/src/disvert_dcmip3.f90
===================================================================
--- codes/icosagcm/trunk/src/disvert_dcmip3.f90	(revision 185)
+++ codes/icosagcm/trunk/src/disvert_dcmip3.f90	(revision 186)
@@ -3,6 +3,9 @@
  
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: ap(:)
+!$OMP THREADPRIVATE(ap)
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: bp(:)
+!$OMP THREADPRIVATE(bp)
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: presnivs(:)
+!$OMP THREADPRIVATE(presnivs)
 
 CONTAINS
Index: codes/icosagcm/trunk/src/disvert_ncar.f90
===================================================================
--- codes/icosagcm/trunk/src/disvert_ncar.f90	(revision 185)
+++ codes/icosagcm/trunk/src/disvert_ncar.f90	(revision 186)
@@ -3,6 +3,9 @@
  
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: ap(:)
+!$OMP THREADPRIVATE(ap)
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: bp(:)
+!$OMP THREADPRIVATE(bp)
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: presnivs(:)
+!$OMP THREADPRIVATE(presnivs)
 
 CONTAINS
Index: codes/icosagcm/trunk/src/disvert_ncarl30.f90
===================================================================
--- codes/icosagcm/trunk/src/disvert_ncarl30.f90	(revision 185)
+++ codes/icosagcm/trunk/src/disvert_ncarl30.f90	(revision 186)
@@ -1,7 +1,11 @@
 MODULE disvert_ncarl30_mod
   USE icosa
+
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: ap(:)
+!$OMP THREADPRIVATE(ap)
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: bp(:)
+!$OMP THREADPRIVATE(bp)
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: presnivs(:)
+!$OMP THREADPRIVATE(presnivs)
 
 CONTAINS
Index: codes/icosagcm/trunk/src/disvert_std.f90
===================================================================
--- codes/icosagcm/trunk/src/disvert_std.f90	(revision 185)
+++ codes/icosagcm/trunk/src/disvert_std.f90	(revision 186)
@@ -2,6 +2,9 @@
   USE icosa
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: ap(:)
+!$OMP THREADPRIVATE(ap)
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: bp(:)
+!$OMP THREADPRIVATE(bp)
   REAL(rstd), SAVE, ALLOCATABLE,TARGET :: presnivs(:)
+!$OMP THREADPRIVATE(presnivs)
 
 CONTAINS
Index: codes/icosagcm/trunk/src/domain.f90
===================================================================
--- codes/icosagcm/trunk/src/domain.f90	(revision 185)
+++ codes/icosagcm/trunk/src/domain.f90	(revision 186)
@@ -58,13 +58,17 @@
   END TYPE t_domain
 
+  INTEGER,SAVE :: ndomain
+  INTEGER,SAVE :: ndomain_glo
+
   TYPE(t_domain),SAVE,ALLOCATABLE,TARGET :: domain(:)
-  INTEGER :: ndomain
   TYPE(t_domain),SAVE,ALLOCATABLE,TARGET :: domain_glo(:)
-  INTEGER :: ndomain_glo
-
-  INTEGER,ALLOCATABLE,SAVE :: domglo_rank(:)
-  INTEGER,ALLOCATABLE,SAVE :: domglo_loc_ind(:)
-  INTEGER,ALLOCATABLE,SAVE :: domloc_glo_ind(:)
-  
+
+  INTEGER,ALLOCATABLE,SAVE :: domglo_rank(:)  ! size : ndomain_glo : mpi rank assigned to a domain 
+  INTEGER,ALLOCATABLE,SAVE :: domglo_loc_ind(:) ! size : ndomain_glo : corresponding local indice for a global domain indice
+  INTEGER,ALLOCATABLE,SAVE :: domloc_glo_ind(:) ! size : ndomain : corresponding global indice for a local domain indice
+
+  LOGICAL, ALLOCATABLE, SAVE :: assigned_domain(:) ! size : ndomain : is an omp task is assigned to this domain
+!$OMP THREADPRIVATE(assigned_domain)
+    
 CONTAINS
 
@@ -423,7 +427,41 @@
       ENDIF
     ENDDO
+
+!$OMP PARALLEL
+    CALL assign_domain_omp
+!$OMP END PARALLEL
+        
     
   END SUBROUTINE  assign_domain      
-    
+   
+  SUBROUTINE assign_domain_omp
+  USE omp_para
+  USE mpipara
+  IMPLICIT NONE
+    INTEGER :: nb_domain
+    INTEGER :: rank, ind, i
+
+    ALLOCATE(assigned_domain(ndomain))
+    
+    ind=0
+    DO rank=0,omp_size-1
+      nb_domain=ndomain/omp_size
+      IF ( rank < MOD(ndomain,omp_size) ) nb_domain=nb_domain+1
+    
+      DO i=1,nb_domain
+       ind=ind+1
+       IF (rank==omp_rank) THEN 
+         assigned_domain(ind)=.TRUE.
+         PRINT *,"Rank ",mpi_rank," task ",rank," local domain : ",ind," global domain ",domloc_glo_ind(ind)
+       ELSE
+         assigned_domain(ind)=.FALSE.
+       ENDIF  
+      ENDDO
+    
+    ENDDO
+    
+  END SUBROUTINE assign_domain_omp
+    
+
           
   SUBROUTINE compute_domain
Index: codes/icosagcm/trunk/src/earth_const.f90
===================================================================
--- codes/icosagcm/trunk/src/earth_const.f90	(revision 185)
+++ codes/icosagcm/trunk/src/earth_const.f90	(revision 186)
@@ -18,5 +18,5 @@
   
   SUBROUTINE init_earth_const
-  USE ioipsl
+  USE getin_mod
   IMPLICIT NONE
   REAL(rstd) :: X=1
Index: codes/icosagcm/trunk/src/etat0.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0.f90	(revision 185)
+++ codes/icosagcm/trunk/src/etat0.f90	(revision 186)
@@ -1,4 +1,5 @@
 MODULE etat0_mod
     CHARACTER(len=255),SAVE :: etat0_type
+!$OMP THREADPRIVATE(etat0_type)
 
 CONTAINS
@@ -26,4 +27,5 @@
     TYPE(t_field),POINTER :: f_u(:)
     TYPE(t_field),POINTER :: f_q(:)
+    
     REAL(rstd),POINTER :: ps(:), mass(:,:)
     LOGICAL :: init_mass
@@ -75,6 +77,7 @@
 
     IF(init_mass) THEN ! initialize mass distribution using ps
-       !$OMP BARRIER
+!       !$OMP BARRIER
        DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/etat0_academic.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0_academic.f90	(revision 185)
+++ codes/icosagcm/trunk/src/etat0_academic.f90	(revision 186)
@@ -10,11 +10,11 @@
   USE kinetic_mod
   IMPLICIT NONE
-    TYPE(t_field),POINTER :: f_ps(:)
-    TYPE(t_field),POINTER :: f_phis(:)
-    TYPE(t_field),POINTER :: f_theta_rhodz(:)
-    TYPE(t_field),POINTER :: f_u(:)
-    TYPE(t_field),POINTER :: f_q(:)
-    TYPE(t_field),POINTER :: f_Ki(:)
-    TYPE(t_field),POINTER :: f_temp(:)
+    TYPE(t_field),POINTER,SAVE :: f_ps(:)
+    TYPE(t_field),POINTER,SAVE :: f_phis(:)
+    TYPE(t_field),POINTER,SAVE :: f_theta_rhodz(:)
+    TYPE(t_field),POINTER,SAVE :: f_u(:)
+    TYPE(t_field),POINTER,SAVE :: f_q(:)
+    TYPE(t_field),POINTER,SAVE :: f_Ki(:)
+    TYPE(t_field),POINTER,SAVE :: f_temp(:)
   
     REAL(rstd),POINTER :: Ki(:,:)
@@ -58,4 +58,5 @@
     
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/etat0_dcmip1.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0_dcmip1.f90	(revision 185)
+++ codes/icosagcm/trunk/src/etat0_dcmip1.f90	(revision 186)
@@ -4,19 +4,35 @@
 
   REAL(rstd), SAVE  :: h0=1.
+!$OMP THREADPRIVATE(h0)
   REAL(rstd), SAVE  :: lon0=3*pi/2
+!$OMP THREADPRIVATE(lon0)
   REAL(rstd), SAVE  :: lat0=0.0
+!$OMP THREADPRIVATE(lat0)
   REAL(rstd), SAVE  :: alpha=0.0
+!$OMP THREADPRIVATE(alpha)
   REAL(rstd), SAVE  :: R0 
+!$OMP THREADPRIVATE(R0)
   REAL(rstd), SAVE  :: lat1=0.
+!$OMP THREADPRIVATE(lat1)
   REAL(rstd), SAVE  :: lat2=0.
+!$OMP THREADPRIVATE(lat2)
   REAL(rstd), SAVE  :: lon1=pi/6
+!$OMP THREADPRIVATE(lon1)
   REAL(rstd), SAVE  :: lon2=-pi/6
+!$OMP THREADPRIVATE(lon2)
   REAL(rstd), SAVE  :: latc1=0.
+!$OMP THREADPRIVATE(latc1)
   REAL(rstd), SAVE  :: latc2=0.
+!$OMP THREADPRIVATE(latc2)
   REAL(rstd), SAVE  :: lonc1=5*pi/6
+!$OMP THREADPRIVATE(lonc1)
   REAL(rstd), SAVE  :: lonc2=7*pi/6
+!$OMP THREADPRIVATE(lonc2)
   REAL(rstd), SAVE  :: zt=1000.0
+!$OMP THREADPRIVATE(zt)
   REAL(rstd), SAVE  :: rt
+!$OMP THREADPRIVATE(rt)
   REAL(rstd), SAVE  :: zc=5000.0
+!$OMP THREADPRIVATE(zc)
 
   PUBLIC etat0
@@ -47,4 +63,5 @@
     
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/etat0_dcmip2.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0_dcmip2.f90	(revision 185)
+++ codes/icosagcm/trunk/src/etat0_dcmip2.f90	(revision 186)
@@ -46,4 +46,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/etat0_dcmip3.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0_dcmip3.f90	(revision 185)
+++ codes/icosagcm/trunk/src/etat0_dcmip3.f90	(revision 186)
@@ -34,4 +34,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/etat0_dcmip4.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0_dcmip4.f90	(revision 185)
+++ codes/icosagcm/trunk/src/etat0_dcmip4.f90	(revision 186)
@@ -12,8 +12,17 @@
   REAL(rstd),PARAMETER :: up0=1
   REAL(rstd) :: latw=2*Pi/9
+!$OMP THREADPRIVATE(latw)
   REAL(rstd) :: pw=34000
+!$OMP THREADPRIVATE(pw)
   REAL(rstd) :: q0=0.021
+!$OMP THREADPRIVATE(q0)
   REAL(rstd) :: lonc
+!$OMP THREADPRIVATE(lonc)
   REAL(rstd) :: latc
+!$OMP THREADPRIVATE(latc)
+
+  INTEGER,SAVE :: testcase
+!$OMP THREADPRIVATE(testcase)  
+
   PUBLIC  etat0
 CONTAINS
@@ -36,6 +45,10 @@
     REAL(rstd),POINTER :: q(:,:,:)
     INTEGER :: ind
+
+    testcase=1
+    CALL getin("dcmip4_testcase",testcase)
     
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -81,12 +94,7 @@
   REAL(rstd) :: lonx,latx
   REAL(rstd) :: dthetaodeta_ave, dthetaodeta, dthetaodlat, duodeta, K, r
-  INTEGER :: testcase
   
     lonc=Pi/9
     latc=2*Pi/9 
-  
-    testcase=1
-    CALL getin("dcmip4_testcase",testcase)
-  
   
     DO l=1,llm
Index: codes/icosagcm/trunk/src/etat0_dcmip5.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0_dcmip5.f90	(revision 185)
+++ codes/icosagcm/trunk/src/etat0_dcmip5.f90	(revision 186)
@@ -16,8 +16,11 @@
   REAL(rstd),PARAMETER :: epsilon=1e-25
   REAL(rstd),PARAMETER :: Rd=287
-  REAL(rstd) :: lonc
-  REAL(rstd) :: latc
+  REAL(rstd),SAVE :: lonc
+!$OMP THREADPRIVATE(lonc)  
+  REAL(rstd),SAVE :: latc
+!$OMP THREADPRIVATE(latc)  
   TYPE(t_field),POINTER :: f_out_i(:)
-  REAL(rstd),POINTER :: out_i(:,:)
+  REAL(rstd),POINTER,SAVE :: out_i(:,:)
+!$OMP THREADPRIVATE(out_i)  
 
   PUBLIC  etat0
@@ -45,4 +48,5 @@
  
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/etat0_heldsz.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0_heldsz.f90	(revision 185)
+++ codes/icosagcm/trunk/src/etat0_heldsz.f90	(revision 186)
@@ -8,10 +8,14 @@
   TYPE(t_field),POINTER :: f_clat(:) ! FIXME, duplication
 
-  REAL(rstd),ALLOCATABLE :: knewt_t(:),kfrict(:)
-
+  REAL(rstd),ALLOCATABLE,SAVE :: knewt_t(:),kfrict(:)
+!$OMP THREADPRIVATE(knewt_t,kfrict)
   LOGICAL, SAVE :: done=.FALSE.
-
-  REAL(rstd) :: teta0,ttp,delt_y,delt_z,eps
-  REAL(rstd) :: knewt_g, k_f,k_c_a,k_c_s
+!$OMP THREADPRIVATE(done)
+
+  REAL(rstd),SAVE :: teta0,ttp,delt_y,delt_z,eps
+!$OMP THREADPRIVATE(teta0,ttp,delt_y,delt_z,eps)
+
+  REAL(rstd),SAVE :: knewt_g, k_f,k_c_a,k_c_s
+!$OMP THREADPRIVATE(knewt_g, k_f,k_c_a,k_c_s)
 
   PUBLIC :: etat0, held_suarez
@@ -69,4 +73,5 @@
     CALL Init_Teq
     DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
        CALL swap_dimensions(ind)
        CALL swap_geometry(ind)
@@ -139,4 +144,5 @@
 
        DO ind=1,ndomain
+          IF (.NOT. assigned_domain(ind)) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
@@ -230,4 +236,5 @@
 
     DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
        CALL swap_dimensions(ind)
        CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/etat0_jablonowsky06.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0_jablonowsky06.f90	(revision 185)
+++ codes/icosagcm/trunk/src/etat0_jablonowsky06.f90	(revision 186)
@@ -23,16 +23,16 @@
   USE vorticity_mod
   IMPLICIT NONE
-    TYPE(t_field),POINTER :: f_ps(:)
-    TYPE(t_field),POINTER :: f_phis(:)
-    TYPE(t_field),POINTER :: f_theta_rhodz(:)
-    TYPE(t_field),POINTER :: f_u(:)
-    TYPE(t_field),POINTER :: f_Ki(:)
-    TYPE(t_field),POINTER :: f_temp(:)
-    TYPE(t_field),POINTER :: f_p(:)
-    TYPE(t_field),POINTER :: f_pks(:)
-    TYPE(t_field),POINTER :: f_pk(:)
-    TYPE(t_field),POINTER :: f_phi(:)
-    TYPE(t_field),POINTER :: f_vort(:)
-    TYPE(t_field),POINTER :: f_q(:)
+    TYPE(t_field),POINTER,SAVE :: f_ps(:)
+    TYPE(t_field),POINTER,SAVE :: f_phis(:)
+    TYPE(t_field),POINTER,SAVE :: f_theta_rhodz(:)
+    TYPE(t_field),POINTER,SAVE :: f_u(:)
+    TYPE(t_field),POINTER,SAVE :: f_Ki(:)
+    TYPE(t_field),POINTER,SAVE :: f_temp(:)
+    TYPE(t_field),POINTER,SAVE :: f_p(:)
+    TYPE(t_field),POINTER,SAVE :: f_pks(:)
+    TYPE(t_field),POINTER,SAVE :: f_pk(:)
+    TYPE(t_field),POINTER,SAVE :: f_phi(:)
+    TYPE(t_field),POINTER,SAVE :: f_vort(:)
+    TYPE(t_field),POINTER,SAVE :: f_q(:)
   
     REAL(rstd),POINTER :: Ki(:,:)
@@ -90,4 +90,5 @@
     
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/etat0_williamson.f90
===================================================================
--- codes/icosagcm/trunk/src/etat0_williamson.f90	(revision 185)
+++ codes/icosagcm/trunk/src/etat0_williamson.f90	(revision 186)
@@ -23,4 +23,5 @@
     
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -61,4 +62,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/exner.f90
===================================================================
--- codes/icosagcm/trunk/src/exner.f90	(revision 185)
+++ codes/icosagcm/trunk/src/exner.f90	(revision 186)
@@ -1,5 +1,7 @@
 MODULE exner_mod
 
-  INTEGER :: caldyn_exner
+  INTEGER,SAVE :: caldyn_exner
+!$OMP THREADPRIVATE(caldyn_exner)
+
   INTEGER, PARAMETER :: lmdz=3, direct=4
 
@@ -21,4 +23,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/field.f90
===================================================================
--- codes/icosagcm/trunk/src/field.f90	(revision 185)
+++ codes/icosagcm/trunk/src/field.f90	(revision 186)
@@ -57,7 +57,13 @@
     INTEGER :: ii_size,jj_size
 
+!$OMP BARRIER
+!$OMP MASTER
     ALLOCATE(field(ndomain))
+!$OMP END MASTER
+!$OMP BARRIER
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
+
       IF(PRESENT(name)) THEN
          field(ind)%name = name
@@ -106,4 +112,5 @@
       
    ENDDO
+!$OMP BARRIER
    
   END SUBROUTINE allocate_field
